# Bang

**Bang** is a command line tool for quick storage and retriveal of text snippets. It is inspired by and very similar to [holman](https://github.com/holman)'s [Boom](https://github.com/holman/boom). The main difference is that Bang has no concept of lists: it is only one level deep. It also has a simpler interface to avoid accidentally creating stuff.

## Installation

Requirements:

* [Node](http://nodejs.org)
* [npm](http://npmjs.org/)

Then:

    $ npm install -g bang

## Get help

    $ bang -h

Or, if you have not yet stored any data, simply run `bang`.

## Add a snippet

    $ bang jimmy http://jimmycuadra.com/

## Retrieve a snippet

    $ bang jimmy
    http://jimmycuadra.com/

The value is copied to your clipboard.

## Delete a snippet

    $ bang -d jimmy

## List all snippets

    $ bang
      jimmy: http://jimmycuadra.com/
       mtnt: http://morethingsneed.to/
    address: 237 Overlook Street

## Storage

Bang's data is serialized to JSON and peristed to a file at `~/.bang`. If you want to share your Bang data across multiple machines, you can move the file to [Dropbox](https://www.dropbox.com/) or some other type of network disk, and then symlink it to `~/.bang` on your local machine.

## Tests

Bang includes a comprehensive test suite using [Jasmine](http://pivotal.github.com/jasmine/). To run it:

    $ npm install -g coffee-script
    $ git clone http://github.com/jimmycuadra/bang.git
    $ cd bang
    $ npm install
    $ cake spec

For continuous testing, use `cake watch`. This also rebuilds CoffeeScript files whenever the tests are run.
